FROM openshift/golang-builder:rhel_8_golang_1.15 AS builder
ENV __doozer=update BUILD_RELEASE=202104160221.p0 BUILD_VERSION=v4.6.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=6 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.6.0-202104160221.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=8210fdc OS_GIT_VERSION=4.6.0-202104160221.p0-8210fdc SOURCE_DATE_EPOCH=1618534944 SOURCE_GIT_COMMIT=8210fdc1920f468f03d6e535230a1b73890d2f93 SOURCE_GIT_TAG=v0.0.0-alpha.0-246-g8210fdc1 SOURCE_GIT_URL=https://github.com/openshift/sdn 
WORKDIR /go/src/github.com/openshift/sdn
COPY . .
RUN make build --warn-undefined-variables
RUN CGO_ENABLED=0 GO_BUILD_FLAGS="-tags no_openssl" make build GO_BUILD_PACKAGES="github.com/openshift/sdn/cmd/sdn-cni-plugin" --warn-undefined-variables

FROM openshift/ose-base:v4.6.0-202104151245.p0
ENV __doozer=update BUILD_RELEASE=202104160221.p0 BUILD_VERSION=v4.6.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=6 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.6.0-202104160221.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=8210fdc OS_GIT_VERSION=4.6.0-202104160221.p0-8210fdc SOURCE_DATE_EPOCH=1618534944 SOURCE_GIT_COMMIT=8210fdc1920f468f03d6e535230a1b73890d2f93 SOURCE_GIT_TAG=v0.0.0-alpha.0-246-g8210fdc1 SOURCE_GIT_URL=https://github.com/openshift/sdn 
COPY --from=builder /go/src/github.com/openshift/sdn/openshift-sdn /usr/bin/openshift-sdn-node
COPY --from=builder /go/src/github.com/openshift/sdn/network-controller /usr/bin/openshift-sdn-controller
COPY --from=builder /go/src/github.com/openshift/sdn/sdn-cni-plugin /opt/cni/bin/openshift-sdn
COPY --from=builder /go/src/github.com/openshift/sdn/host-local /usr/bin/cni/osdn-host-local

RUN INSTALL_PKGS=" \
      openvswitch2.11 container-selinux socat ethtool nmap-ncat \
      libmnl libnetfilter_conntrack conntrack-tools \
      libnfnetlink iproute procps-ng openssl \
      iputils binutils xz util-linux dbus nftables \
      " && \
    yum install -y --setopt=tsflags=nodocs --setopt=skip_missing_names_on_install=False $INSTALL_PKGS && \
    mkdir -p /etc/sysconfig/cni/net.d && \
    yum clean all && rm -rf /var/cache/*

COPY ./images/iptables-scripts/iptables /usr/sbin/
COPY ./images/iptables-scripts/iptables-save /usr/sbin/
COPY ./images/iptables-scripts/iptables-restore /usr/sbin/
COPY ./images/iptables-scripts/ip6tables /usr/sbin/
COPY ./images/iptables-scripts/ip6tables-save /usr/sbin/
COPY ./images/iptables-scripts/ip6tables-restore /usr/sbin/

LABEL \
        io.k8s.display-name="OpenShift SDN" \
        io.k8s.description="This is a component of OpenShift and contains the default SDN implementation." \
        io.openshift.tags="openshift,sdn,sdn-controller" \
        name="openshift/ose-sdn" \
        com.redhat.component="ose-node-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="Networking" \
        io.openshift.maintainer.subcomponent="openshift-sdn" \
        release="202104160221.p0" \
        io.openshift.build.commit.id="8210fdc1920f468f03d6e535230a1b73890d2f93" \
        io.openshift.build.source-location="https://github.com/openshift/sdn" \
        io.openshift.build.commit.url="https://github.com/openshift/sdn/commit/8210fdc1920f468f03d6e535230a1b73890d2f93" \
        version="v4.6.0"

